$ERROR ALL ON
$STACK 4096
$DIM ARRAY
$LIB LPT ON, GRAPH OFF, IPRINT ON, COM OFF
$STRING 4
$FLOAT EMULATE

REDIM 	PROGRAM$(1000)  	' Array to store program source code
DIM 	VAR$	(256)   	' Array to store variable names
DIM 	VALUE$	(256)   	' Array to store variable contents
DIM 	ARG$	(16)    	' Buffer array for argument stack pushpop
DIM	GosubStack%(32)		' Stack to store return pointers
DIM     LITERAL$(16)            ' Storage of parameter names

SHARED Row%, Col%, Cur% 	' Store original cursor position and state
SHARED ProgLine%, Prog%         ' Current line number and running status
SHARED MaxLine%			' How many lines in the program

SHARED ARG$(), ArgPtr%          ' Argument stack for parsing statements
SHARED VAR$(), VALUE$()         ' Storage arrays for variables
SHARED Literal$(), NextVar%     ' Literal variable name and Next free var #
SHARED PROGRAM$(), ORG$         ' Source code array and saved screen image
SHARED Token$,TokenType,P,Arg$  ' Used by the CALC function.
SHARED GosubStack%(), GosubPtr% ' Used for GOSUB..RETURN
SHARED ExitFlag%                ' Used by IF and other logic commands
SHARED RepeatFlag%              ' Used by WHILE and UNTIL

' Set a trap for CONTROL-C to break the program
KEY 15,chr$(4,46,&H70)
ON KEY(15) GOSUB BREAK
KEY(15) ON


' A simple way to call the interpreter. With PROGRAM$() empty and Prog%
' set to 0 it will start in command mode.  Put a program into the array
' and call PROGRUN with Prog% set to NOT 0 and ProgLine% set to 0 or 1
' and PROGRUN will start out by running the program instead.  Be sure to
' end your program with QUIT or END in order to exit the interpreter
' without going into command mode when the program ends.

ON ERROR GOTO ErrorHandler
PROGRUN PROGRAM$()
END

' =========================================================================
SUB PROGRUN (RUNPROG$())
EXIT FAR AT ExitFar:
PROGINPUT: ' Here we create a string variable called PROG$.  this variable
           ' will either be the next line to execute in the program (prog%=1)
           ' or it will be entered at the keyboard (prog%=0).

IF Prog% THEN      'single-step parent program if currently running
 	stp:       'where we skip to if the line is blank

   	IF Progline% > UBOUND(RUNPROG$) THEN  '..... no more program to run!
        	Prog% = 0                     ' stop executing
                GOTO PROGINPUT                ' go back to command mode
        ELSE
   		IF RTRIM$(RUNPROG$(Progline%)) = "" THEN '.....blank line!
                	Progline% = Progline% + 1        ' skip it
                	GOTO stp                         ' and try the next
                END IF
   	Prog$ = RTRIM$(RUNPROG$(Progline%))              ' trim what we have
	END IF

ELSE  ' ...program is NOT running, get user input in command mode !!!!!!!!

	LOCATE ,,1 '......................turn on cursor
	PRINT CHR$(13) + "OK" '...........display a prompt
	LINE INPUT Prog$ '................get user input

        ' From here you can enter a direct statement like QUIT or PRINT,
        ' but you can also write a program by entering a LINE NUMBER
        ' followed by a line of code.

        IF VAL(Prog$) THEN '.............................. has a line number!
	 	A% = VAL(Prog$): B% = INSTR(Prog$, " ") '..... get the line $
	        IF B% = 0 OR A% > UBOUND(RUNPROG$()) THEN '...... is it good?
         		PRINT "Illegal program line." + CHR$(7) '........NOT!
                 	GOTO PROGINPUT '....................Train, Sucker
	 	END IF
         	LET RUNPROG$(A%)=MID$(Prog$, B% + 1) '......add line to array
	 	IF A%>MaxLine% THEN MaxLine%=A% '...........find highest line
		GOTO ProgInput '.............. don't execute it, just go back
	END IF
END IF

Bak$=Prog$

RepeatLabel:
RepeatFlag%=0 '................... set to true if statement is to be repeated
ExitFlag%=0 '............... set to true if statement is aborted by condition
PREP Prog$ '.......................... PREPROCESS THE STATEMENT !!!!!!!!!!!!!
EXEC Prog$ '.......................... EXECUTE THE PROGRAM LINE !!!!!!!!!!!!!
IF RepeatFlag% THEN Prog$=Bak$:GOTO RepeatLabel

DO:Dummy$=POPARG$:LOOP WHILE ArgPtr%>0 '..... remove any extraneous arguments

IF Prog% THEN INCR Progline% '.if the program is still running then increment
GOTO ProgInput '..............the line pointer and execute the next statement

' yeah, but what about changing the value of Progline% with GOTO and stuff?
' what about running a new program with LOAD or RUN commands?  That's all
' handled in the EXEC sub.

ExitFar:
END SUB

SUB EXEC (Prg$)

IF INSTR(Prg$,ANY " ,;") THEN
	RPrg$=MID$(Prg$, INSTR(Prg$,ANY " ,;")+1)
	Prg$=LEFT$(Prg$, INSTR(Prg$,ANY " ,;")-1)
	Rprg$=LTRIM$(RTRIM$(RPrg$))
	EXEC RPrg$
        IF ExitFlag% THEN EXIT SUB
END IF

SELECT CASE UCASE$(Prg$)

        $INCLUDE "LOADRUN.CMD"   ' Run, Load, Quit, List, etc.
        $INCLUDE "VIDEO_IO.CMD"  ' Print, Input, TAB, CR, etc.
        $INCLUDE "VARIABLE.CMD"  ' LET, SET, etc.
        $INCLUDE "FLOW.CMD"      ' GOTO, GOSUB, other flow control commands
        $INCLUDE "CALC.CMD"      ' CALC, arithmetic processing commands.
        $INCLUDE "LOGIC.CMD"     ' IF, WHILE, UNTIL, etc.
        $INCLUDE "FUNCTION.CMD"  ' functions (ucase, lcase, chr, etc)

	CASE ELSE

                ' It's a variable.  Check to see if it has been defined.
                IF VAL(PRG$) THEN
                	PUSHARG PRG$
                ELSE
        	ARRAY SCAN VAR$(1),COLLATE UCASE,=PRG$, TO i%
                IF i% THEN
                	PUSHARG VALUE$(i%) '............. yes, push the value
                ELSE
                	PUSHARG "00" '......................... no, push "00"
                END IF
                LITERAL$(ArgPtr%)=UCASE$(PRG$) '....... save the literal name
	        '.......We may need to remember the name of the var for later
                END IF
END SELECT
END SUB

SUB PUSHARG(X$)
IF LEN(X$) THEN
	INCR ArgPtr%
	ARG$(ArgPtr%)=X$
END IF
END SUB

FUNCTION POPARG$
	IF ArgPtr%>0 THEN
	POPARG$=ARG$(ArgPtr%)
	DECR ArgPtr%
	END IF
END FUNCTION


ErrorHandler:
RESTORE ErrorMessages
DO
	READ E, E$
	IF E=999 THEN EXIT DO
LOOP UNTIL E=ERR

PRINT CHR$(7)+CrLf$+"ERROR:"+STR$(ERR)+"  "+E$
PRINT "Continue? (y/n) --> ";
DO
	A$=UCASE$(INPUT$(1))
        PRINT a$
	IF A$="N" THEN END
LOOP WHILE A$<>"Y"
RESUME NEXT


Break:
PRINT CHR$(7)+CrLf$+"BREAK: Program interrupted by user"
PRINT "Resume? (y/n) --> ";
DO
	A$=UCASE$(INPUT$(1))
        PRINT A$;
	IF A$="N" THEN END
LOOP WHILE A$<>"Y"
RETURN


$INCLUDE "ERRORMSG.BAS" ' Data statements with error messages
$INCLUDE "CALC.BAS"     ' arithmetic calculator routine (RCD)
$INCLUDE "PREP.BAS"     ' Interpreted code pre-processor subroutine

